uses crt;

type
  string_20 = string[20]; {  - ⨯ , ࠭   }

  {  ॢ }
  PTreeNode = ^TreeNode;
  TreeNode = object
  public
    constructor init(_s: string; _parent: PTreeNode);

  public
    Color: integer; {  : 0 = , 1 =  }
    left, right, parent,
    duplicates: PTreeNode; { ᮪ 㡫⮢ ( ⠫ 㤠,   㦭) }

    data_string: string_20;
    deleted: boolean;      {   "" 㤠 }
  end;

  RBTree = object
  public
    constructor init;
    destructor done;

    function Search(s: string): integer;
    { 頥 +1, ᫨ ப   ॢ,  -1 ᫨  ⠬  }
    
    function SearchFirstMatch(s: string): PTreeNode;
    { ⠥ 筮 ⠪ ,   Search,  頥 㪠⥫
       ⨯ PTreeNode   室騩  }
       
    procedure Insert(s: string);
    {     ॢ }
    function InsertItem(s: string; node: PTreeNode): PTreeNode;

    function Remove(s: string): boolean;
    {   ப }

    procedure LoadFromFile(fn: string); { 㦠 ॢ  ⥪⮢ 䠩 ( ॠ) }
    procedure SaveToFile(var f: text);  { ࠭ ॢ  ⥪⮢ 䠩 }

    function LeftDepth: integer;  { 室 㡨  ॢ }
    function RightDepth: integer; { 室 㡨 ࠢ ॢ }
    function NumberOfLeaves(p: PTreeNode): integer;
    { 室 ᫮ 쥢  ॢ }

  public
    root: PTreeNode;

  private
    procedure LeftRotation(node: PTreeNode);
    procedure RightRotation(node: PTreeNode);
    { "樨" (), ᯮ㥬  ⠢  ஢ ॢ }
    function TreeDepth(p: PTreeNode): integer;
    { ᨢ 㭪  宦 㡨 ॢ,  ୥  P }

    procedure DeleteTree(p: PTreeNode);
    {  뢠  楤  㤠 ॢ }
    procedure SaveNode(level: integer;
              const node: PTreeNode; var f: text);
    { ᨢ 楤 ࠭ 㧫  ⮢ 䠩 F }
  end;


Const
  {   㧫 }
  node_Red   = 1;
  node_Black = 0;

constructor TreeNode.init(_s: string; _parent: PTreeNode);
begin
  data_string := _s;
  left := nil; right := nil;
  parent := _parent; { ⥫  । }

  Duplicates := nil; { 砫쭮  㧫  㡫⮢ }
  Color := node_Red; {  㧫 ⠭ "묨" }
  Deleted := False;  {  㧥  㤠 }
end;

{
  㭪 ࠢ ப ( ஡  ਭ  )
}
function compare(s1, s2: string): integer;

  procedure trim(var s: string);
  begin
    while s[length(s)] = ' ' do delete(s, length(s), 1);
  end;

begin

  trim(s1); trim(s2);
  if s1 < s2 then compare := -1
  else if s1 > s2 then compare := +1
       else compare := 0;

end;

constructor RBTree.init;
begin
  root := nil;
end;
destructor RBTree.done;
begin
  DeleteTree(Root);
  { DeleteTree ᢮   }
end;


procedure RBTree.DeleteTree(p: PTreeNode);
begin
  if p <> nil then begin
    DeleteTree(p^.Left);  {   ॢ }
    DeleteTree(p^.Right); {  ࠢ ॢ }
    DeleteTree(p^.Duplicates);
    dispose(p);
  end;
  p := nil; {    ᯮ }
end;

{
   ⠢   ந 3 :
  1.  㧥   "" - ""
  2.  㧥 , "" - "",  㧥 -  ⮬
  3.  㧥 , "" - "",  㧥 - ࠢ ⮬
}
procedure RBTree.Insert(s: string);
{   㧥  ࠭ ப }
var
  node, node_2: PTreeNode;
begin
  node := InsertItem(s, root); { ⠢ ப  ॢ }

  if node = nil then exit; {  ॢ  㦭 }

  while(node <> root) and (node^.parent^.color = node_Red) do begin

    { ஢塞, 室  㧥   ॢ }
    if node^.parent = node^.parent^.parent^.left then begin

      node_2 := node^.parent^.parent^.right; {  node2 "拉" 襣 㧫 }
      
      { ᫨ "" ᭮ 梥 -  砩 1 }
      if (node_2 <> nil) and (node_2^.Color = node_Red) then begin
        node^.parent^.Color := node_Black; { 塞 梥 "த⥫"   }
        node_2^.Color := node_Black;       { 塞 梥 "廊"   }
        node^.Parent^.Parent^.Color := node_Red; {  ""  }
        node := node^.Parent^.Parent;            {   設 ॢ  ஢ ⥫ ࠢ }
      end
      else begin { "" - ୮ 梥, 砩 2  3 }
      
        if Node = Node^.Parent^.Right then begin { ஢塞  砩 3 }
          Node := Node^.Parent; {  - ࠢ ⮬,   ࠧ 砩 3... }
          LeftRotation(Node);   { ...  ॡ  "" }
        end;
        Node^.Parent^.Color := node_Black;       { ⠭  砥 2... }
        Node^.Parent^.Parent^.Color := node_Red; { ...  3 }
        RightRotation(Node^.Parent^.Parent);
        
      end;

    end
    else begin { 㧥 -  ࠢ ॢ }

      node_2 := Node^.Parent^.Parent^.Left; {  node2 "拉" 襣 㧫 }
      { ᫨ "" ᭮ 梥 -  砩 1 }
      if(node_2 <> nil) and (node_2^.Color = node_Red) then begin
        Node^.Parent^.Color := node_Black;       { 塞 梥 "த⥫"   }
        Node_2^.Color := node_Black;             { 塞 梥 "廊"   }
        Node^.Parent^.Parent^.Color := node_Red; {  ""  }
        Node := Node^.Parent^.Parent;            {   設 ॢ... }
      end
      else begin { "" - "", 砩 2  3 }

        { ஢塞  砩 3 (""  "ࠢ"  ⠬) }
        if Node = Node^.Parent^.Left then begin
          Node := Node^.Parent; {  -  ⮬,   ࠧ 砩 3... }
          RightRotation(Node);  { ...  ॡ ࠢ "" }
        end;
        Node^.Parent^.Color := node_Black;       { ⠭  砥 2... }
        Node^.Parent^.Parent^.Color := node_Red; { ...  3 }
        LeftRotation(Node^.Parent^.Parent);
      end;

    end

  end;

  {  ࠢ  ७ ॢ    }
  Root^.Color := node_Black;
end;


function RBTree.InsertItem(s: string; node: PTreeNode): PTreeNode;
var
  comparison: integer;
  GreaterThanLeft, LessThanRight: boolean;
  T: PTreeNode;
begin

  if root = nil then begin

    root := new(PTreeNode, init(s, nil)); { ⠭ ७ }
    
    {  ࠢ  ७ ॢ    }
    root^.Color := node_Black;
    InsertItem := root; exit

  end;

  while True do begin

    comparison := compare(s, node^.data_string);

    if node^.Deleted then begin
      {  砫 ஢ਬ,   㧥 "㤠".
        ᫨  ⠪,    ᯮ짮 "㤠" 㧥
         ࠭  , ᫨   㤥 室
          "⮬" }
      if node^.Left = nil then GreaterThanLeft := true
      else
        { ( 砥, ᫨ compare() < 0): ப   祬  ⮬,
          ⮬ "㤠" 㧥   ᯮ짮  ࠭   }
        GreaterThanLeft := (compare(s, node^.left^.data_string) > 0);

      if node^.Right = nil then LessThanRight := true
      else
        { ( 砥, ᫨ compare() < 0): ப   祬 ࠢ ⮬,
          ⮬ "㤠" 㧥   ᯮ짮  ࠭   }
        LessThanRight := (compare(s, node^.right^.data_string) > 0);

      if GreaterThanLeft and LessThanRight then begin
        { "㤠" 㧥  ᯮ짮  ࠭   }
        node^.data_string := s;
        node^.Deleted := false; { 㤥  "㤠"   }
        InsertItem := nil; exit

        {
        頥 NIL, ⮡  "権" ॢ, .. , 祭
        ண 뫮 , 室  ᢮ 
        }
      end;

    end;

    if comparison < 0 then begin
      { ᫨ Left , 頥  㧥 㤠 }
      if Node^.Left = nil then begin
        Node^.Left := new(PTreeNode, init(s, Node)); { 塞  㧥 ... }
        InsertItem := Node^.Left;                    { ...   ⮬ }
        exit
      end
      else Node := Node^.Left; { ஢  ॢ }
    end

    else
      if comparison > 0 then begin
        { ᫨ Right , 頥  㧥 㤠 }
        if Node^.Right = nil then begin
          Node^.Right := new(PTreeNode, init(s, Node)); { 塞  㧥 ... }
          InsertItem := Node^.Right;                    { ...  ࠢ ⮬ }
          exit
        end
        else Node := Node^.Right; { ஢ ࠢ ॢ }
      end
      else begin { 㧥 - 㡫 }

        T := node;
        { 室  ᯨ᪠ 㡫⮢ }
        while(T^.Duplicates <> nil) do T := T^.Duplicates;
        T^.Duplicates := new(PTreeNode, init(s, T));
        InsertItem := nil; exit
        {
        頥 NIL, ⮡  "権" ॢ, ..
           ᯨ᮪ 㡫⮢
        }
      end;
  end;

end;


function RBTree.Remove(s: string): boolean;
var T, prev_node, node: PTreeNode;
begin
  Remove := False;
  Node := SearchFirstMatch(s); {  室騩 㧥  ॢ }
  if node = nil then exit;     { ப  뫠  - 室 }

  if node^.Duplicates <> nil then begin

    {
      ᫨  㡫 -    㡫⮢  
       㤠塞 
    }
    T := node;
    while T^.Duplicates <> nil do begin
      prev_node := T;
      T := T^.Duplicates;
    end;
    node^.data_string := T^.data_string;
    { 㥬 ᮤন ᫥ 㡫   ,  㤥 㤠 }
    dispose(T);
    prev_node^.Duplicates := nil;
    { "ᥪ" ᫥  ᯨ᪠ 㡫⮢ }

    Remove := true; { 㤠 뫮 ᯥ }
  end
  else
    Node^.Deleted := true; { 砥 㧥  "㤠"  "" 㤠 }
  Remove := True
end;


function RBTree.Search(s: string): integer;
var
  node: PTreeNode;
  comparison: integer;
begin
  Search := -1;

  node := root;
  while Node <> nil do begin

    comparison := compare(s, node^.data_string);
    if comparison < 0 then Node := Node^.Left { ᬠਢ  ॢ }
    else
      if comparison < 0 then Node := Node^.Right { ᬠਢ ࠢ ॢ }
      else
        if Node^.Deleted then exit
          { ᫨ 㧥 祭  㤠 -   ਭ   , 室 }
        else begin
          { ப  }
          search := 1; exit
        end;
  end;
  {    }
end;

function RBTree.SearchFirstMatch(s: string): PTreeNode;
{ 頥 㪠⥫   㧥, ࠭騩  ப }
var
  node: PTreeNode;
  comparison: integer;
begin
  SearchFirstMatch := nil;

  node := root;
  while Node <> nil do begin

    comparison := compare(s, node^.data_string);
    if comparison < 0 then Node := Node^.Left { ᬠਢ  ॢ }
    else
      if comparison > 0 then Node := Node^.Right { ᬠਢ ࠢ ॢ }
      else
        if Node^.Deleted then exit
          { ᫨ 㧥 祭  㤠 -   ਭ   , 室 }
        else begin
          { ப  }
          SearchFirstMatch := node; exit
        end;

  end;
end;

procedure RBTree.SaveToFile(var f: text);
{
  ࠭ 㧫  אַ (室饬) 浪
}
begin
  { 뢠 ४ }
  SaveNode(0, root, f);
end;

procedure RBTree.SaveNode(level: integer;
          const node: PTreeNode; var f: text);
const
  _color: array[0 .. 1] of char = ('B', 'R');
begin
  if node <> nil then begin

    if not node^.Deleted then begin
      writeln(f, '':3*level,
              node^.data_string + ' ('+_color[node^.Color]+')');
    end;
    SaveNode(level + 1, node^.Left, f);  { ࠭ 㧫  ॢ }
    SaveNode(level + 1, node^.Right, f); { ࠭ 㧫 ࠢ ॢ }

  end;
end;

procedure RBTree.LoadFromFile(fn: string);
begin
  (*  ॠ *)
end;

function RBTree.LeftDepth: integer;
begin
  LeftDepth := TreeDepth(Root^.Left); { 塞  ॢ }
end;

function RBTree.RightDepth: integer;
begin
  RightDepth := TreeDepth(Root^.Right); { 塞 ࠢ ॢ  }
end;

function RBTree.TreeDepth(p: PTreeNode): integer;
var _left, _right: integer;
begin
  _left := 0; _right := 0;
  if p^.Left <> nil then
    _left := TreeDepth(p^.Left);   {  㡨  ॢ }
  if p^.Right <> nil then
    _right := TreeDepth(p^.Right); {  㡨 ࠢ ॢ }

  if _left > _right then     { ஢塞,  ॢ "㡦" }
    TreeDepth := _left + 1   { ୥ 㡨  ॢ + 1 }
  else
    TreeDepth := _right + 1; { ୥ 㡨 ࠢ ॢ + 1 }
end;


function RBTree.NumberOfLeaves(p: PTreeNode): integer;
var total: integer;
begin
  NumberOfLeaves := 1;

  total := 0;
  if (p^.Left = nil) and (p^.Right = nil) then exit; { 㧥  "⮬" }

  { ⠥ ᫮ 쥢   ॢ }
  if p^.Left <> nil then inc(total, NumberOfLeaves(p^.Left));
  { ⠥ ᫮ 쥢  ࠢ ॢ }
  if p^.Right <> nil then inc(total, NumberOfLeaves(p^.Right));

  NumberOfLeaves := total;
  {  頥 饥 ⢮ 쥢  ॢ }
end;

procedure RBTree.LeftRotation(node: PTreeNode);
var Right: PTreeNode;
begin
  Right := node^.Right; { hold node's right child }

  { make the node's right child its right child's left child }
  node^.Right := Right^.Left;
  if Right^.Left <> nil then
    Right^.Left^.Parent := Node; { point the child to its new parent }

  if Right <> nil then
    Right^.Parent := Node^.Parent; { point the child to its new parent }

  if Node^.Parent <> nil then begin { if node is not the root }
    if Node = Node^.Parent^.Left then { if node is a left child }
      Node^.Parent^.Left := Right   { make node's right child its parent's left child }
    else
      Node^.Parent^.Right := Right; { make node's right child its parent's right child }
  end
  else
    Root := Right; { node's right child is now the root }

  Right^.Left := Node; { node becomes its right child's left child }
  if Node <> nil then
    Node^.Parent := Right; { point node to its new parent }
end;

procedure RBTree.RightRotation(node: PTreeNode);
var Left: PTreeNode;
begin
  Left := node^.Left; { hold node's left child }

  { make the node's left child its left child's right child }
  Node^.Left := Left^.Right;
  if Left^.Right <> nil then
    Left^.Right^.Parent := Node; { point the child to its new parent }

  if Left <> nil then
    Left^.Parent := Node^.Parent; { point the child to its new parent }

  if Node^.Parent <> nil then begin { if node is not the root }
    if Node = Node^.Parent^.Right then { if node is a right child }
      Node^.Parent^.Right := Left { make node's left child its parent's right child }
    else
      Node^.Parent^.Left := Left; { make node's left child its parent's left child }
  end
  else
    Root := Left; { node's left child is now the root }

  Left^.Right := Node; { node becomes its left child's right child }
  if Node <> nil then
    Node^.Parent := Left; { point node to its new parent }
end;


{ ⢥, ணࠬ,  ᯮ짮  }
var
  console: text;
  s: string_20;
  tree: RBTree;

begin
  assigncrt(console);
  rewrite(console);
  tree.init;

  {
     ᫥ ᫥⥫쭮 ப:
    one
    two
    three
    four
    five
  }
  repeat
    write('enter new string (20 chars max): '); readln(s);
    if s <> '' then begin
      tree.insert(s);
      Writeln('**');
        tree.SaveToFile(console); { 뢮 ॢ  ᮫ }
      writeln('**');
    end;
  until s = '';
  tree.SaveToFile(console);

  { ஢塞 ࠡ Search }
  if tree.search('four') = 1 then writeln('found')
  else writeln('not found');

  { ஢塞 ࠡ Remove }
  tree.Remove('four');
  tree.SaveToFile(console);

  tree.done;
  close(console);
end.